from __future__ import annotations

# HID KEYCODES
HID_KEY_NONE = b"\x00"
HID_KEY_A = b"\x04"
HID_KEY_B = b"\x05"
HID_KEY_C = b"\x06"
HID_KEY_D = b"\x07"
HID_KEY_E = b"\x08"
HID_KEY_F = b"\x09"
HID_KEY_G = b"\x0a"
HID_KEY_H = b"\x0b"
HID_KEY_I = b"\x0c"
HID_KEY_J = b"\x0d"
HID_KEY_K = b"\x0e"
HID_KEY_L = b"\x0f"
HID_KEY_M = b"\x10"
HID_KEY_N = b"\x11"
HID_KEY_O = b"\x12"
HID_KEY_P = b"\x13"
HID_KEY_Q = b"\x14"
HID_KEY_R = b"\x15"
HID_KEY_S = b"\x16"
HID_KEY_T = b"\x17"
HID_KEY_U = b"\x18"
HID_KEY_V = b"\x19"
HID_KEY_W = b"\x1a"
HID_KEY_X = b"\x1b"
HID_KEY_Y = b"\x1c"
HID_KEY_Z = b"\x1d"
HID_KEY_1 = b"\x1e"
HID_KEY_2 = b"\x1f"
HID_KEY_3 = b"\x20"
HID_KEY_4 = b"\x21"
HID_KEY_5 = b"\x22"
HID_KEY_6 = b"\x23"
HID_KEY_7 = b"\x24"
HID_KEY_8 = b"\x25"
HID_KEY_9 = b"\x26"
HID_KEY_0 = b"\x27"
HID_KEY_ENTER = b"\x28"
HID_KEY_ESCAPE = b"\x29"
HID_KEY_BACKSPACE = b"\x2a"
HID_KEY_TAB = b"\x2b"
HID_KEY_SPACE = b"\x2c"
HID_KEY_MINUS = b"\x2d"
HID_KEY_EQUAL = b"\x2e"
HID_KEY_BRACKET_LEFT = b"\x2f"
HID_KEY_BRACKET_RIGHT = b"\x30"
HID_KEY_BACKSLASH = b"\x31"
HID_KEY_EUROPE_1 = b"\x32"
HID_KEY_SEMICOLON = b"\x33"
HID_KEY_APOSTROPHE = b"\x34"
HID_KEY_GRAVE = b"\x35"
HID_KEY_COMMA = b"\x36"
HID_KEY_PERIOD = b"\x37"
HID_KEY_SLASH = b"\x38"
HID_KEY_CAPS_LOCK = b"\x39"
HID_KEY_F1 = b"\x3a"
HID_KEY_F2 = b"\x3b"
HID_KEY_F3 = b"\x3c"
HID_KEY_F4 = b"\x3d"
HID_KEY_F5 = b"\x3e"
HID_KEY_F6 = b"\x3f"
HID_KEY_F7 = b"\x40"
HID_KEY_F8 = b"\x41"
HID_KEY_F9 = b"\x42"
HID_KEY_F10 = b"\x43"
HID_KEY_F11 = b"\x44"
HID_KEY_F12 = b"\x45"
HID_KEY_PRINT_SCREEN = b"\x46"
HID_KEY_SCROLL_LOCK = b"\x47"
HID_KEY_PAUSE = b"\x48"
HID_KEY_INSERT = b"\x49"
HID_KEY_HOME = b"\x4a"
HID_KEY_PAGE_UP = b"\x4b"
HID_KEY_DELETE = b"\x4c"
HID_KEY_END = b"\x4d"
HID_KEY_PAGE_DOWN = b"\x4e"
HID_KEY_ARROW_RIGHT = b"\x4f"
HID_KEY_ARROW_LEFT = b"\x50"
HID_KEY_ARROW_DOWN = b"\x51"
HID_KEY_ARROW_UP = b"\x52"
HID_KEY_NUM_LOCK = b"\x53"
HID_KEY_KEYPAD_DIVIDE = b"\x54"
HID_KEY_KEYPAD_MULTIPLY = b"\x55"
HID_KEY_KEYPAD_SUBTRACT = b"\x56"
HID_KEY_KEYPAD_ADD = b"\x57"
HID_KEY_KEYPAD_ENTER = b"\x58"
HID_KEY_KEYPAD_1 = b"\x59"
HID_KEY_KEYPAD_2 = b"\x5a"
HID_KEY_KEYPAD_3 = b"\x5b"
HID_KEY_KEYPAD_4 = b"\x5c"
HID_KEY_KEYPAD_5 = b"\x5d"
HID_KEY_KEYPAD_6 = b"\x5e"
HID_KEY_KEYPAD_7 = b"\x5f"
HID_KEY_KEYPAD_8 = b"\x60"
HID_KEY_KEYPAD_9 = b"\x61"
HID_KEY_KEYPAD_0 = b"\x62"
HID_KEY_KEYPAD_DECIMAL = b"\x63"
HID_KEY_EUROPE_2 = b"\x64"
HID_KEY_APPLICATION = b"\x65"
HID_KEY_POWER = b"\x66"
HID_KEY_KEYPAD_EQUAL = b"\x67"
HID_KEY_F13 = b"\x68"
HID_KEY_F14 = b"\x69"
HID_KEY_F15 = b"\x6a"
HID_KEY_F16 = b"\x6b"
HID_KEY_F17 = b"\x6c"
HID_KEY_F18 = b"\x6d"
HID_KEY_F19 = b"\x6e"
HID_KEY_F20 = b"\x6f"
HID_KEY_F21 = b"\x70"
HID_KEY_F22 = b"\x71"
HID_KEY_F23 = b"\x72"
HID_KEY_F24 = b"\x73"
HID_KEY_EXECUTE = b"\x74"
HID_KEY_HELP = b"\x75"
HID_KEY_MENU = b"\x76"
HID_KEY_SELECT = b"\x77"
HID_KEY_STOP = b"\x78"
HID_KEY_AGAIN = b"\x79"
HID_KEY_UNDO = b"\x7a"
HID_KEY_CUT = b"\x7b"
HID_KEY_COPY = b"\x7c"
HID_KEY_PASTE = b"\x7d"
HID_KEY_FIND = b"\x7e"
HID_KEY_MUTE = b"\x7f"
HID_KEY_VOLUME_UP = b"\x80"
HID_KEY_VOLUME_DOWN = b"\x81"
HID_KEY_LOCKING_CAPS_LOCK = b"\x82"
HID_KEY_LOCKING_NUM_LOCK = b"\x83"
HID_KEY_LOCKING_SCROLL_LOCK = b"\x84"
HID_KEY_KEYPAD_COMMA = b"\x85"
HID_KEY_KEYPAD_EQUAL_SIGN = b"\x86"
HID_KEY_KANJI1 = b"\x87"
HID_KEY_KANJI2 = b"\x88"
HID_KEY_KANJI3 = b"\x89"
HID_KEY_KANJI4 = b"\x8a"
HID_KEY_KANJI5 = b"\x8b"
HID_KEY_KANJI6 = b"\x8c"
HID_KEY_KANJI7 = b"\x8d"
HID_KEY_KANJI8 = b"\x8e"
HID_KEY_KANJI9 = b"\x8f"
HID_KEY_LANG1 = b"\x90"
HID_KEY_LANG2 = b"\x91"
HID_KEY_LANG3 = b"\x92"
HID_KEY_LANG4 = b"\x93"
HID_KEY_LANG5 = b"\x94"
HID_KEY_LANG6 = b"\x95"
HID_KEY_LANG7 = b"\x96"
HID_KEY_LANG8 = b"\x97"
HID_KEY_LANG9 = b"\x98"
HID_KEY_ALTERNATE_ERASE = b"\x99"
HID_KEY_SYSREQ_ATTENTION = b"\x9a"
HID_KEY_CANCEL = b"\x9b"
HID_KEY_CLEAR = b"\x9c"
HID_KEY_PRIOR = b"\x9d"
HID_KEY_RETURN = b"\x9e"
HID_KEY_SEPARATOR = b"\x9f"
HID_KEY_OUT = b"\xa0"
HID_KEY_OPER = b"\xa1"
HID_KEY_CLEAR_AGAIN = b"\xa2"
HID_KEY_CRSEL_PROPS = b"\xa3"
HID_KEY_EXSEL = b"\xa4"

# RESERVED                                      0xA5-DF
HID_KEY_CONTROL_LEFT = b"\x01"
HID_KEY_SHIFT_LEFT = b"\x02"
HID_KEY_ALT_LEFT = b"\x04"
HID_KEY_GUI_LEFT = b"\x08"
HID_KEY_CONTROL_RIGHT = b"\x10"
HID_KEY_SHIFT_RIGHT = b"\x20"
HID_KEY_ALT_RIGHT = b"\x40"
HID_KEY_GUI_RIGHT = b"\x80"


conv_table: list[tuple[int, bytes]] = [
    (0, b"\x00"),  # 0x00 Null
    (0, b"\x00"),  # 0x01
    (0, b"\x00"),  # 0x02
    (0, b"\x00"),  # 0x03
    (0, b"\x00"),  # 0x04
    (0, b"\x00"),  # 0x05
    (0, b"\x00"),  # 0x06
    (0, b"\x00"),  # 0x07
    (0, HID_KEY_BACKSPACE),  # 0x08 Backspace
    (0, HID_KEY_TAB),  # 0x09 Tab
    (0, HID_KEY_ENTER),  # 0x0A Line Feed
    (0, b"\x00"),  # 0x0B
    (0, b"\x00"),  # 0x0C
    (0, HID_KEY_ENTER),  # 0x0D CR
    (0, b"\x00"),  # 0x0E
    (0, b"\x00"),  # 0x0F
    (0, b"\x00"),  # 0x10
    (0, b"\x00"),  # 0x11
    (0, b"\x00"),  # 0x12
    (0, b"\x00"),  # 0x13
    (0, b"\x00"),  # 0x14
    (0, b"\x00"),  # 0x15
    (0, b"\x00"),  # 0x16
    (0, b"\x00"),  # 0x17
    (0, b"\x00"),  # 0x18
    (0, b"\x00"),  # 0x19
    (0, b"\x00"),  # 0x1A
    (0, HID_KEY_ESCAPE),  # 0x1B Escape
    (0, b"\x00"),  # 0x1C
    (0, b"\x00"),  # 0x1D
    (0, b"\x00"),  # 0x1E
    (0, b"\x00"),  # 0x1F
    (0, HID_KEY_SPACE),  # 0x20
    (1, HID_KEY_1),  # 0x21 !
    (1, HID_KEY_APOSTROPHE),  # 0x22 "
    (1, HID_KEY_3),  # 0x23 #
    (1, HID_KEY_4),  # 0x24 $
    (1, HID_KEY_5),  # 0x25 %
    (1, HID_KEY_7),  # 0x26 &
    (0, HID_KEY_APOSTROPHE),  # 0x27 '
    (1, HID_KEY_9),  # 0x28 (
    (1, HID_KEY_0),  # 0x29 )
    (1, HID_KEY_8),  # 0x2A *
    (1, HID_KEY_EQUAL),  # 0x2B +
    (0, HID_KEY_COMMA),  # 0x2C ,
    (0, HID_KEY_MINUS),  # 0x2D -
    (0, HID_KEY_PERIOD),  # 0x2E .
    (0, HID_KEY_SLASH),  # 0x2F /
    (0, HID_KEY_0),  # 0x30 0
    (0, HID_KEY_1),  # 0x31 1
    (0, HID_KEY_2),  # 0x32 2
    (0, HID_KEY_3),  # 0x33 3
    (0, HID_KEY_4),  # 0x34 4
    (0, HID_KEY_5),  # 0x35 5
    (0, HID_KEY_6),  # 0x36 6
    (0, HID_KEY_7),  # 0x37 7
    (0, HID_KEY_8),  # 0x38 8
    (0, HID_KEY_9),  # 0x39 9
    (1, HID_KEY_SEMICOLON),  # 0x3A :
    (0, HID_KEY_SEMICOLON),  # 0x3B ;
    (1, HID_KEY_COMMA),  # 0x3C <
    (0, HID_KEY_EQUAL),  # 0x3D =
    (1, HID_KEY_PERIOD),  # 0x3E >
    (1, HID_KEY_SLASH),  # 0x3F ?
    (1, HID_KEY_2),  # 0x40 @
    (1, HID_KEY_A),  # 0x41 A
    (1, HID_KEY_B),  # 0x42 B
    (1, HID_KEY_C),  # 0x43 C
    (1, HID_KEY_D),  # 0x44 D
    (1, HID_KEY_E),  # 0x45 E
    (1, HID_KEY_F),  # 0x46 F
    (1, HID_KEY_G),  # 0x47 G
    (1, HID_KEY_H),  # 0x48 H
    (1, HID_KEY_I),  # 0x49 I
    (1, HID_KEY_J),  # 0x4A J
    (1, HID_KEY_K),  # 0x4B K
    (1, HID_KEY_L),  # 0x4C L
    (1, HID_KEY_M),  # 0x4D M
    (1, HID_KEY_N),  # 0x4E N
    (1, HID_KEY_O),  # 0x4F O
    (1, HID_KEY_P),  # 0x50 P
    (1, HID_KEY_Q),  # 0x51 Q
    (1, HID_KEY_R),  # 0x52 R
    (1, HID_KEY_S),  # 0x53 S
    (1, HID_KEY_T),  # 0x55 T
    (1, HID_KEY_U),  # 0x55 U
    (1, HID_KEY_V),  # 0x56 V
    (1, HID_KEY_W),  # 0x57 W
    (1, HID_KEY_X),  # 0x58 X
    (1, HID_KEY_Y),  # 0x59 Y
    (1, HID_KEY_Z),  # 0x5A Z
    (0, HID_KEY_BRACKET_LEFT),  # 0x5B [
    (0, HID_KEY_BACKSLASH),  # 0x5C '\'
    (0, HID_KEY_BRACKET_RIGHT),  # 0x5D ]
    (1, HID_KEY_6),  # 0x5E ^
    (1, HID_KEY_MINUS),  # 0x5F _
    (0, HID_KEY_GRAVE),  # 0x60 `
    (0, HID_KEY_A),  # 0x61 a
    (0, HID_KEY_B),  # 0x62 b
    (0, HID_KEY_C),  # 0x63 c
    (0, HID_KEY_D),  # 0x66 d
    (0, HID_KEY_E),  # 0x65 e
    (0, HID_KEY_F),  # 0x66 f
    (0, HID_KEY_G),  # 0x67 g
    (0, HID_KEY_H),  # 0x68 h
    (0, HID_KEY_I),  # 0x69 i
    (0, HID_KEY_J),  # 0x6A j
    (0, HID_KEY_K),  # 0x6B k
    (0, HID_KEY_L),  # 0x6C l
    (0, HID_KEY_M),  # 0x6D m
    (0, HID_KEY_N),  # 0x6E n
    (0, HID_KEY_O),  # 0x6F o
    (0, HID_KEY_P),  # 0x70 p
    (0, HID_KEY_Q),  # 0x71 q
    (0, HID_KEY_R),  # 0x72 r
    (0, HID_KEY_S),  # 0x73 s
    (0, HID_KEY_T),  # 0x75 t
    (0, HID_KEY_U),  # 0x75 u
    (0, HID_KEY_V),  # 0x76 v
    (0, HID_KEY_W),  # 0x77 w
    (0, HID_KEY_X),  # 0x78 x
    (0, HID_KEY_Y),  # 0x79 y
    (0, HID_KEY_Z),  # 0x7A z
    (1, HID_KEY_BRACKET_LEFT),  # 0x7B {
    (1, HID_KEY_BACKSLASH),  # 0x7C |
    (1, HID_KEY_BRACKET_RIGHT),  # 0x7D }
    (1, HID_KEY_GRAVE),  # 0x7E ~
    (0, HID_KEY_DELETE),  # 0x7F Delete
]
